﻿Imports System.ComponentModel

Public Class Customer
  Implements INotifyPropertyChanged

  Public Event PropertyChanged( _
    ByVal sender As Object, _
    ByVal e As PropertyChangedEventArgs) _
    Implements INotifyPropertyChanged.PropertyChanged

  Protected Overridable Sub OnPropertyChanged(ByVal PropertyName As String)
    ' Raise the event, and make this procedure
    ' overridable, should someone want to inherit from
    ' this class and override this behavior:
    RaiseEvent PropertyChanged( _
      Me, New PropertyChangedEventArgs(PropertyName))
  End Sub

  Public Sub New(ByVal Name As String)
    ' Set the backing field so that
    ' you don't raise the PropertyChanged event
    ' when you first create the Customer.
    _name = Name
  End Sub

  Private _name As String
  Public Property Name() As String
    Get
      Return _name
    End Get
    Set(ByVal value As String)
      If _name <> value Then
        _name = value
        OnPropertyChanged("Name")
      End If
    End Set
  End Property
End Class
